
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CommentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const comments = await db.comments.create(
            {
                id: data.id || undefined,
        
        target_type: data.target_type
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        posted_at: data.posted_at
        ||
        null
            ,
            
        is_pinned: data.is_pinned
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await comments.setProblem_report( data.problem_report || null, {
            transaction,
        });
        
        await comments.setSolution_proposal( data.solution_proposal || null, {
            transaction,
        });
        
        await comments.setCourse( data.course || null, {
            transaction,
        });
        
        await comments.setLesson( data.lesson || null, {
            transaction,
        });
        
        await comments.setAuthor( data.author || null, {
            transaction,
        });
        
        await comments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return comments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const commentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                target_type: item.target_type
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                posted_at: item.posted_at
            ||
            null
            ,
            
                is_pinned: item.is_pinned
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const comments = await db.comments.bulkCreate(commentsData, { transaction });

        // For each item created, replace relation files
        

        return comments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const comments = await db.comments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.target_type !== undefined) updatePayload.target_type = data.target_type;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.posted_at !== undefined) updatePayload.posted_at = data.posted_at;
        
        
        if (data.is_pinned !== undefined) updatePayload.is_pinned = data.is_pinned;
        
        
        updatePayload.updatedById = currentUser.id;

        await comments.update(updatePayload, {transaction});

        
        
        if (data.problem_report !== undefined) {
            await comments.setProblem_report(
              
              data.problem_report,
              
              { transaction }
            );
        }
        
        if (data.solution_proposal !== undefined) {
            await comments.setSolution_proposal(
              
              data.solution_proposal,
              
              { transaction }
            );
        }
        
        if (data.course !== undefined) {
            await comments.setCourse(
              
              data.course,
              
              { transaction }
            );
        }
        
        if (data.lesson !== undefined) {
            await comments.setLesson(
              
              data.lesson,
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await comments.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await comments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return comments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const comments = await db.comments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of comments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of comments) {
                await record.destroy({transaction});
            }
        });


        return comments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const comments = await db.comments.findByPk(id, options);

        await comments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await comments.destroy({
            transaction
        });

        return comments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const comments = await db.comments.findOne(
            { where },
            { transaction },
        );

        if (!comments) {
            return comments;
        }

        const output = comments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.problem_report = await comments.getProblem_report({
            transaction
        });
        
        
        output.solution_proposal = await comments.getSolution_proposal({
            transaction
        });
        
        
        output.course = await comments.getCourse({
            transaction
        });
        
        
        output.lesson = await comments.getLesson({
            transaction
        });
        
        
        output.author = await comments.getAuthor({
            transaction
        });
        
        
        output.organizations = await comments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.problem_reports,
        as: 'problem_report',
        
        where: filter.problem_report ? {
          [Op.or]: [
            { id: { [Op.in]: filter.problem_report.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.problem_report.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.solution_proposals,
        as: 'solution_proposal',
        
        where: filter.solution_proposal ? {
          [Op.or]: [
            { id: { [Op.in]: filter.solution_proposal.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.solution_proposal.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.courses,
        as: 'course',
        
        where: filter.course ? {
          [Op.or]: [
            { id: { [Op.in]: filter.course.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.course.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lessons,
        as: 'lesson',
        
        where: filter.lesson ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lesson.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.lesson.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'comments',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            
            if (filter.posted_atRange) {
                const [start, end] = filter.posted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.target_type) {
                where = {
                    ...where,
                target_type: filter.target_type,
            };
            }
            
            if (filter.is_pinned) {
                where = {
                    ...where,
                is_pinned: filter.is_pinned,
            };
            }
            


      

      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.comments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'comments',
                        'content',
                        query,
                    ),
                ],
            };
        }

        const records = await db.comments.findAll({
            attributes: [ 'id', 'content' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content,
        }));
    }

    
};

